/*##############################################################################
suggpow add soft damping
1430
 * https://www.microbot.it/sketches/_12A_Linear_Current_Sensor_test_sketch.ino
  12A Linear Current Sensor test sketch v1.0
 * Read current value from the sensor and print its value on the Serial Monitor
 Connections:
 * BOARD -> ARDUINO
 * Vcc   -> 3.3V
 * GND   -> GND
 * OUT   -> PIN A0
---------------------------
   oled
https://lastminuteengineers.com/oled-display-esp32-tutorial/?utm_content=cmp-true
---------------------------
   deepsleep if current < x mA  duration y minutes  (check ..)
wakeup when display button
show time before shutoff

ssd1306 consumption
https://bitbanksoftware.blogspot.com/2019/06/how-much-current-do-oled-displays-use.html
On,but Black
4uA

code for SSD1306 OLED emulator
https://randomnerdtutorials.com/esp8266-deep-sleep-with-arduino-ide/
---------------------------
ssd1306 as on OSD
128x64
https://rickkas7.github.io/DisplayGenerator/index.html

#############
######  future dvlt ?
RTC clock ?
https://randomnerdtutorials.com/esp8266-nodemcu-ds3231-real-time-clock-arduino/
##############################################################################*/

#include <SPI.h>
//i2c pins
//D1 GPIO5  SCL
//D2 GPIO4  SDA
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Fonts/Org_01.h>  //space odyssey font ..
//#include <U8g2lib.h>  //for the ssd1306 shutdown

// Please UNCOMMENT one of the contructor lines below
// U8g2 Contructor List (Frame Buffer)
// The complete list is available here: https://github.com/olikraus/u8g2/wiki/u8g2setupcpp
// Please update the pin numbers according to your setup. Use U8X8_PIN_NONE if the reset pin is not connected

//U8G2_SSD1306_128X64_NONAME_F_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE);   //LL 64
//U8G2_SSD1306_128X64_NONAME_F_SW_I2C u8g2(U8G2_R0, /* clock=*/ SCL, /* data=*/ SDA, /* reset=*/ U8X8_PIN_NONE);   // All Boards without Reset of the Display
//U8G2_SSD1306_128X64_NONAME u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE, /* clock=*/ SCL, /* data=*/ SDA);
//U8G2_SSD1306_128X64_NONAME_1_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE, /* clock=*/ SCL, /* data=*/ SDA);
//  U8G2_SSD1306_128X64_NONAME_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE, /* clock=*/ SCL, /* data=*/ SDA);

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

// Declaration for SSD1306 display connected using I2C ( and spi ?)
#define OLED_RESET     -1 // Reset pin
#define SCREEN_ADDRESS 0x3C

Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

char INOFileName[] = __FILE__;
const char compile_date[] = __DATE__ " " __TIME__;
/*
  Serial.println(__FILE__);
  Serial.println(String("Compiled ") + String(compile_date));
  Serial.println("━━━━━━━━━━━━━━━━━━━━━━━━━━━━━");
  //////////////////////////////////////////
*/
// Define constants and variables
const int analogInPin = A0; // Analog input pin that the current sensor is attached to
int sensorValue = 0;        // raw value read from the sensor
float sensorCvtA = 0;      // A converted value of the sensor reading
float sensorPct =0 ;        // +- pct

float BattV = 25 ;  // Real bat is 37V, but Motor is announced 250W only for power display

bool TimeOutActive =false ;
// unsigned long StartTimeOutClk =0 ; //start TimeOutmills counter
////
//// millis() MANDATORY USE UNSIGNED LONG WITH %i
//// DO !NOT! MIX WITH time_t  !
///
// SETTINGS ///////////////////////////////////////////////////////////////////////////////
//info: head light is 5W , 100 mA !
// below DEPEND OF PROP FACTOR AFTER SENSOR READING  !
//  see  sensorCvtA computation !
// measures 0.026 steady,  0.185 headlamp only => use LowLimitPowerOff =0 A
//
float LowLimitPowerOff = 0.036 ;  //POWEROFF Amps  under this value, poweroff after POWEROFF TimeOutmills
unsigned long DampingDurmills = 800 ; //1 * 1000;    // DISPLAY UPDATE INTERVALL and DAMPING mills seconds
unsigned long TimeOutmills = 30 * 1000;  // POWEROFF timeout   minutes =15*60 sleep when not in us
int Zoffset = 532 ; //532 ; // -12A..+12A  => 0..3.3 V   0A => 1.65V !  cal 'Zero Amps' value must be be 512
// END SETTINGS ///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
unsigned long StartTimeOutClk = 0 ; //timeoutmills counter
unsigned long int DispcurrentTime, DispnextTime;  //used by display
//damping ////////////////////////////////////////////////////////////////////////////////////
unsigned long DampingtClk = 0 ; //timeoutmills counter
unsigned long DampingEndmils = millis() + DampingDurmills  ;
unsigned long dampsensorValue = 0;
unsigned long dampcnt =0 ;

/////////////////////////////////////////////////////////////////////////////////////
String mconvertMillsToHHMMSS(long int mils,  char*  thou, char*  tmin, char*  tsec) {  // millis to  HH:MM:SS
  char ret[9];
  long int isec = mils / 1000;
  long int ihou = isec / 3600;
  isec %= 3600;
  long int imin = isec / 60;
  isec %= 60;
  //long int tsecs = sec;
  sprintf(ret, "%02d:%02d.%02d", ihou, imin, isec);  //8 chars
  sprintf(thou, "%02d", ihou  );  //String(ihou ;)
  sprintf(tmin, "%02d", imin  );
  sprintf(tsec, "%02d", isec  );
  return ret;
}
/////////////////////////////////////////////////////////////////////////////////////
void setup() {
  Serial.begin(115200);       // Serial Port initialization
  Serial.printf("\n\r\n\r━━━━━━━━━━━━━━━━━━━━━━━━━━━━━\n\r");
  Serial.println(INOFileName);
  Serial.println(String("Compiled ") + String(compile_date));
  Serial.println("━━━━━━━━━━━━━━━━━━━━━━━━━━━━━");

  Serial.println(">>>Info power off :");
  Serial.printf("If current < %0.3f, power off after %i sec\n\r", LowLimitPowerOff, TimeOutmills/1000 );
  Serial.printf("Display interval %0.1f sec\n\r", (float)(DampingDurmills/1000) );
  //////////////////////////////////////////
  //Serial.println(">>>Init u8g2:");
  //u8g2.begin();
  delay(100);
  Serial.println(">>>Init display:");
  if(!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) {
    Serial.println(F("SSD1306 allocation failed"));
    //for(;;); // Don't proceed, loop forever
  }
  //u8g2.powerOn();  //power on  (check if usefull)
  display.display() ;
  delay (1000);// display adafruit 'star' logo
  display.clearDisplay();
  display.setTextColor(WHITE);
  /*  cool, but not really readable...
  display.setFont(&Org_01); // :-) HAL fonts !
  display.setCursor(0,16);  // font is based low left char  ..
  display.setTextSize(1);
  */
  display.setCursor(0,0); // top left
  display.setTextSize(0);
  display.setFont(NULL);

  display.println("Luc's SUGGPow") ;
  display.println(INOFileName) ;
  display.println(String("Compiled ") + String(compile_date));
  display.printf("Current<%0.3f->off %i sec\n\r", LowLimitPowerOff, TimeOutmills/1000 );
  display.printf("Display interval %0.2f sec\n\r", (float)DampingDurmills/1000 );

  display.display();
  delay (3000) ;  // time to read ...
}
/////////////////////////////////////////////////////////////////////////////////////
void displayssd1306(float sensorPct,float sensorCvtA ) {
  //128x64 Aaah voilaaa!
  display.clearDisplay();
  //thermo bar
  //display.setCursor(0, 0);
  //display.drawRect(0, 56, 128, 8, 1); // hbar frame
  int hbar= (int)(128*((float)sensorPct/100)) ; //0..128  pct of 128 ?
  float Power = sensorCvtA * BattV ;

  display.setTextColor(WHITE);
  //pct power value remove decimals
  display.setTextSize(6);
  //display.setFont(NULL);  //  TBC ?
  //display.setCursor(30, 0);// top center
  display.drawRect(0, 0, 128, 10, 1); // hbar frame
  //void fillRect(x, y , width, height,color);
  if(TimeOutActive) {
    display.fillRect(1, 4, hbar, 2, 1);///thinner bar for countdown
  }
  else {
    display.fillRect(0, 2, hbar, 6, 1);
  }
  display.printf("%0f ", sensorCvtA );
  // pct large HAL font
  display.setFont(&Org_01);  //font
  display.setCursor(30, 40);// top center
  display.println((int)sensorPct);

  //hh:mm:ss  vertically run time
  display.setTextSize(0);
  display.setFont(NULL);
  char hh[3]; char  mm[3]; char  ss[3];
  mconvertMillsToHHMMSS(millis(),  hh,  mm,  ss );
  display.setCursor(0, 16);  display.printf("H %s", hh  );
  display.setCursor(0, 26);  display.printf("M %s", mm  );
  display.setCursor(0, 36);  display.printf("S %s", ss  );


  // Amp and Watt
  display.setTextSize(1);
  display.setFont(NULL);
  display.setCursor(10, 56);
  display.printf("%0.3f A (%0.2f W)", sensorCvtA, Power );


  display.display();
}
/*/////////////////////////////////////////////////////////////////////////////////////
void displaytimeout(unsigned long shutdownin) {  //mills
  sensorPct =  (float)(shutdownin*100)/TimeOutmills   ;  // countdown on thermo bar
  //sensorCvtA = shutdownin ;
}
*/
/////////////////////////////////////////////////////////////////////////////////////
void loop() {
  sensorValue = analogRead(analogInPin) ;               // reads the sensor value and convert it
  unsigned long mils = millis() ;

  dampsensorValue+=sensorValue ;
  dampcnt++;
//Display delay 1000 msec, count 18303
//18:09:34.075 ->  A0 input 648 => 26.6 %, 6.04 A
//  Yaw ! 18K measures/sec !

  if (mils >= DampingEndmils) { // end of display damp dur ?
    DampingEndmils = mils + DampingDurmills  ; // new value damp dur at..
    sensorValue = (float) (dampsensorValue/dampcnt) ;
    sensorValue=(int) sensorValue ;
    //Serial.printf("\n\r Sum %i, divided by count %i, sensor  %0.1f\n\r", dampsensorValue, dampcnt, sensorValue  );
    Serial.printf("\n\r Display delay %i msec, count %i\n\r", DampingDurmills, dampcnt );
    dampsensorValue=0;
    dampcnt=0;
    sensorCvtA = ((float)(sensorValue-Zoffset) * 5 / 0.185) / 1024; //
    sensorPct =  (((float)sensorValue-Zoffset)/512)*100 ; //pct for positive value (half scale) 512..1024
    ///////////////////////////////////////////////////
    // poweroff TimeOutmills handling
    if (sensorCvtA <= LowLimitPowerOff) {
      //Serial.printf("LowLimitPowerOff detected .. TimeOutmills %i , StartTimeOutClk %i\n\r", TimeOutmills, StartTimeOutClk );
      if (TimeOutActive) {
        unsigned long PowerOffmils = StartTimeOutClk + TimeOutmills  ;
        //Serial.printf("TimeOutActive mils %i, StartTimeOutClk %i, PowerOffmils %i, TimeOutmills %i \n\r",mils,StartTimeOutClk,PowerOffmils,TimeOutmills );
        //Serial.printf("TimeOutActive  mils / PowerOffmils: %i / %i \n\r",mils ,PowerOffmils);
        unsigned long shutdownin =  PowerOffmils - mils ;  //  mills !
        Serial.printf(", shutdown in %i sec ", shutdownin/1000 );  //
        //displaytimeout(PowerOffmils - mils);
        sensorPct =  (float)(shutdownin*100)/TimeOutmills   ;  // countdown on thermo bar
        if (mils >= PowerOffmils ) {
          Serial.printf("\n\rEnter 'deep sleep' mode until RESET pin is connected\n\r to Gnd\n\r");
          display.clearDisplay(); display.display();
          ESP.deepSleep(0);
          //delay (5000) ; TimeOutActive=false ;  // uncomment and comment out above  for test
        }
      }
      else {
        StartTimeOutClk = millis() ;
        TimeOutActive=true ;
        //Serial.printf("\n\r>>>StartTimeOutClk=%i \n\r", StartTimeOutClk );
      }
    }// (sensorCvtA <= LowLimitPowerOff)
    else {
     TimeOutActive=false;  // reset if above LowLimitPowerOff low current limit
    }
    //end of TimeOutmills handling
    ///////////////////////////////////////////////////
    //Serial.printf("Sensor value= %f A , now millis %i     ", sensorCvtA , millis());
    Serial.printf("\n\rA0 input %i => %0.3f %%, %0.3f A", sensorValue, sensorPct, sensorCvtA );  //%0.xf   for x decimal display
    //Sensor value 5 = -99.0pct , -13.38 A Shutdown in 1 sec
    // display handling
    displayssd1306(sensorPct, sensorCvtA) ;
    //delay(200); // usedamping
  }
}
